#include <bits/stdc++.h>
using namespace std;

bool moze(vector<int>& v) {
    int n = v.size();
    bool izbr = false;
    for (int i = 1; i < n; i++) {
        if (v[i] < v[i-1]) {
            if (izbr) {
                return false;
            }
            izbr = true;
            if (i > 1 && v[i] < v[i-2]) {
                v[i] = v[i-1];
            }
        }
    }
    return true;
}

int main() {
    int n, q;
    cin >> n;
    vector<int> a(n);
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    cin >> q;
    while (q--) {
        int l, r;
        cin >> l >> r;
        vector<int> sub(a.begin() + l - 1, a.begin() + r);
        cout << (moze(sub) ? "DA" : "NE") << endl;
    }
    return 0;
}